Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4108)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4109)
@@ -2296,53 +2526,53 @@
           diss_d    = diss_t(k-1)
           
-          ibit11 = REAL( IBITS(advc_flags_1(k,j,i),11,1), KIND = wp )
-          ibit10 = REAL( IBITS(advc_flags_1(k,j,i),10,1), KIND = wp )
-          ibit9  = REAL( IBITS(advc_flags_1(k,j,i),9,1),  KIND = wp )
+          ibit2 = REAL( IBITS(advc_flags_m(k,j,i),2,1), KIND = wp )
+          ibit1 = REAL( IBITS(advc_flags_m(k,j,i),1,1), KIND = wp )
+          ibit0 = REAL( IBITS(advc_flags_m(k,j,i),0,1), KIND = wp )
           
-          ibit14 = REAL( IBITS(advc_flags_1(k,j,i),14,1), KIND = wp )
-          ibit13 = REAL( IBITS(advc_flags_1(k,j,i),13,1), KIND = wp )
-          ibit12 = REAL( IBITS(advc_flags_1(k,j,i),12,1), KIND = wp )
+          ibit5 = REAL( IBITS(advc_flags_m(k,j,i),5,1), KIND = wp )
+          ibit4 = REAL( IBITS(advc_flags_m(k,j,i),4,1), KIND = wp )
+          ibit3 = REAL( IBITS(advc_flags_m(k,j,i),3,1), KIND = wp )
           
-          ibit17 = REAL( IBITS(advc_flags_1(k,j,i),17,1), KIND = wp )
-          ibit16 = REAL( IBITS(advc_flags_1(k,j,i),16,1), KIND = wp )
-          ibit15 = REAL( IBITS(advc_flags_1(k,j,i),15,1), KIND = wp )
+          ibit8 = REAL( IBITS(advc_flags_m(k,j,i),8,1), KIND = wp )
+          ibit7 = REAL( IBITS(advc_flags_m(k,j,i),7,1), KIND = wp )
+          ibit6 = REAL( IBITS(advc_flags_m(k,j,i),6,1), KIND = wp )
 !
 !--       Calculate the divergence of the velocity field. A respective
 !--       correction is needed to overcome numerical instabilities introduced
 !--       by a not sufficient reduction of divergences near topography.
-          div = ( ( u_comp(k)       * ( ibit9 + ibit10 + ibit11 )             &
-                - ( u(k,j,i)   + u(k,j,i-1)   )                               &
-                                    * (                                       &
-                     REAL( IBITS(advc_flags_1(k,j,i-1),9,1),  KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j,i-1),10,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j,i-1),11,1), KIND = wp )     &
-                                      )                                       &
-                  ) * ddx                                                     &
-               +  ( ( v_comp(k) + gv ) * ( ibit12 + ibit13 + ibit14 )         &
-                  - ( v(k,j,i)   + v(k,j,i-1 )  )                             &
-                                    * (                                       &
-                     REAL( IBITS(advc_flags_1(k,j-1,i),12,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j-1,i),13,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j-1,i),14,1), KIND = wp )     &
-                                      )                                       &
-                  ) * ddy                                                     &
-               +  ( w_comp(k)   * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 )&
-                -   w_comp(k-1) * rho_air_zw(k-1)                             &
-                                    * (                                       &
-                     REAL( IBITS(advc_flags_1(k-1,j,i),15,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k-1,j,i),16,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k-1,j,i),17,1), KIND = wp )     &
-                                      )                                       &  
-                  ) * drho_air(k) * ddzw(k)                                   &
-                ) * 0.5_wp
-
-          tend(k,j,i) = tend(k,j,i) - (                                       &
-                            ( flux_r(k) + diss_r(k)                           &
-                          -   flux_l_u(k,j,tn) - diss_l_u(k,j,tn) ) * ddx     &
-                          + ( flux_n(k) + diss_n(k)                           &
-                          -   flux_s_u(k,tn) - diss_s_u(k,tn)     ) * ddy     &
-                          + ( ( flux_t(k) + diss_t(k) )                       &
-                          -   ( flux_d    + diss_d    )                       &
-                                                    ) * drho_air(k) * ddzw(k) &
+          div = ( ( u_comp(k)       * ( ibit0 + ibit1 + ibit2 )                &
+                - ( u(k,j,i)   + u(k,j,i-1)   )                                &
+                                    * (                                        &
+                     REAL( IBITS(advc_flags_m(k,j,i-1),0,1),  KIND = wp )      &
+                   + REAL( IBITS(advc_flags_m(k,j,i-1),1,1), KIND = wp )       &
+                   + REAL( IBITS(advc_flags_m(k,j,i-1),2,1), KIND = wp )       &
+                                      )                                        &
+                  ) * ddx                                                      &
+               +  ( ( v_comp(k) + gv ) * ( ibit3 + ibit4 + ibit5 )             &
+                  - ( v(k,j,i)   + v(k,j,i-1 )  )                              &
+                                    * (                                        &
+                     REAL( IBITS(advc_flags_m(k,j-1,i),3,1), KIND = wp )       &
+                   + REAL( IBITS(advc_flags_m(k,j-1,i),4,1), KIND = wp )       &
+                   + REAL( IBITS(advc_flags_m(k,j-1,i),5,1), KIND = wp )       &
+                                      )                                        &
+                  ) * ddy                                                      &
+               +  ( w_comp(k)   * rho_air_zw(k) * ( ibit6 + ibit7 + ibit8 )    &
+                -   w_comp(k-1) * rho_air_zw(k-1)                              &
+                                    * (                                        &
+                     REAL( IBITS(advc_flags_m(k-1,j,i),6,1), KIND = wp )       &
+                   + REAL( IBITS(advc_flags_m(k-1,j,i),7,1), KIND = wp )       &
+                   + REAL( IBITS(advc_flags_m(k-1,j,i),8,1), KIND = wp )       &
+                                      )                                        &  
+                  ) * drho_air(k) * ddzw(k)                                    &
+                ) * 0.5_wp                                                     
+                                                                               
+          tend(k,j,i) = tend(k,j,i) - (                                        &
+                            ( flux_r(k) + diss_r(k)                            &
+                          -   flux_l_u(k,j,tn) - diss_l_u(k,j,tn) ) * ddx      &
+                          + ( flux_n(k) + diss_n(k)                            &
+                          -   flux_s_u(k,tn) - diss_s_u(k,tn)     ) * ddy      &
+                          + ( ( flux_t(k) + diss_t(k) )                        &
+                          -   ( flux_d    + diss_d    )                        &
+                                                    ) * drho_air(k) * ddzw(k)  &
                                        ) + div * u(k,j,i)
 
@@ -2450,13 +2680,13 @@
        INTEGER(iwp)  ::  tn        !< number of OpenMP thread
        
-       REAL(wp)      ::  ibit18   !< flag indicating 1st-order scheme along x-direction
-       REAL(wp)      ::  ibit19   !< flag indicating 3rd-order scheme along x-direction
-       REAL(wp)      ::  ibit20   !< flag indicating 5th-order scheme along x-direction
-       REAL(wp)      ::  ibit21   !< flag indicating 1st-order scheme along y-direction 
-       REAL(wp)      ::  ibit22   !< flag indicating 3rd-order scheme along y-direction
-       REAL(wp)      ::  ibit23   !< flag indicating 3rd-order scheme along y-direction
-       REAL(wp)      ::  ibit24   !< flag indicating 1st-order scheme along z-direction
-       REAL(wp)      ::  ibit25   !< flag indicating 3rd-order scheme along z-direction
-       REAL(wp)      ::  ibit26   !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)      ::  ibit9    !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)      ::  ibit10   !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)      ::  ibit11   !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)      ::  ibit12   !< flag indicating 1st-order scheme along y-direction 
+       REAL(wp)      ::  ibit13   !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)      ::  ibit14   !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)      ::  ibit15   !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)      ::  ibit16   !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)      ::  ibit17   !< flag indicating 3rd-order scheme along z-direction
        REAL(wp)      ::  diss_d   !< artificial dissipation term at grid box bottom
        REAL(wp)      ::  div      !< divergence on v-grid
@@ -2498,20 +2728,20 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit20 = REAL( IBITS(advc_flags_1(k,j,i-1),20,1), KIND = wp )
-             ibit19 = REAL( IBITS(advc_flags_1(k,j,i-1),19,1), KIND = wp )
-             ibit18 = REAL( IBITS(advc_flags_1(k,j,i-1),18,1), KIND = wp )
+             ibit11 = REAL( IBITS(advc_flags_m(k,j,i-1),11,1), KIND = wp )
+             ibit10 = REAL( IBITS(advc_flags_m(k,j,i-1),10,1), KIND = wp )
+             ibit9  = REAL( IBITS(advc_flags_m(k,j,i-1),9,1),  KIND = wp )
 
              u_comp(k)        = u(k,j-1,i) + u(k,j,i) - gu
              flux_l_v(k,j,tn) = u_comp(k) * (                                 &
-                              ( 37.0_wp * ibit20 * adv_mom_5                  &
-                           +     7.0_wp * ibit19 * adv_mom_3                  &
-                           +              ibit18 * adv_mom_1                  &
+                              ( 37.0_wp * ibit11 * adv_mom_5                  &
+                           +     7.0_wp * ibit10 * adv_mom_3                  &
+                           +              ibit9  * adv_mom_1                  &
                               ) *                                             &
                                         ( v(k,j,i)   + v(k,j,i-1) )           &
-                       -      (  8.0_wp * ibit20 * adv_mom_5                  &
-                           +              ibit19 * adv_mom_3                  &
+                       -      (  8.0_wp * ibit11 * adv_mom_5                  &
+                           +              ibit10 * adv_mom_3                  &
                               ) *                                             &
                                         ( v(k,j,i+1) + v(k,j,i-2) )           &
-                       +      (           ibit20 * adv_mom_5                  &
+                       +      (           ibit11 * adv_mom_5                  &
                               ) *                                             &
                                         ( v(k,j,i+2) + v(k,j,i-3) )           &
@@ -2519,14 +2749,14 @@
 
               diss_l_v(k,j,tn) = - ABS( u_comp(k) ) * (                       &
-                              ( 10.0_wp * ibit20 * adv_mom_5                  &
-                           +     3.0_wp * ibit19 * adv_mom_3                  &
-                           +              ibit18 * adv_mom_1                  &
+                              ( 10.0_wp * ibit11 * adv_mom_5                  &
+                           +     3.0_wp * ibit10 * adv_mom_3                  &
+                           +              ibit9  * adv_mom_1                  &
                               ) *                                             &
                                         ( v(k,j,i)   - v(k,j,i-1) )           &
-                       -      (  5.0_wp * ibit20 * adv_mom_5                  &
-                           +              ibit19 * adv_mom_3                  &
+                       -      (  5.0_wp * ibit11 * adv_mom_5                  &
+                           +              ibit10 * adv_mom_3                  &
                               ) *                                             &
                                         ( v(k,j,i+1) - v(k,j,i-2) )           &
-                       +      (           ibit20 * adv_mom_5                  &
+                       +      (           ibit11 * adv_mom_5                  &
                               ) *                                             &
                                         ( v(k,j,i+2) - v(k,j,i-3) )           &
@@ -2537,11 +2767,11 @@
           DO  k = nzb_max_l+1, nzt
 
-             u_comp(k)           = u(k,j-1,i) + u(k,j,i) - gu
+             u_comp(k)        = u(k,j-1,i) + u(k,j,i) - gu
              flux_l_v(k,j,tn) = u_comp(k) * (                                 &
-                             37.0_wp * ( v(k,j,i) + v(k,j,i-1)   )            &
+                             37.0_wp * ( v(k,j,i)   + v(k,j,i-1)   )          &
                            -  8.0_wp * ( v(k,j,i+1) + v(k,j,i-2) )            &
                            +           ( v(k,j,i+2) + v(k,j,i-3) ) ) * adv_mom_5
              diss_l_v(k,j,tn) = - ABS( u_comp(k) ) * (                        &
-                             10.0_wp * ( v(k,j,i) - v(k,j,i-1)   )            &
+                             10.0_wp * ( v(k,j,i)   - v(k,j,i-1)   )          &
                            -  5.0_wp * ( v(k,j,i+1) - v(k,j,i-2) )            &
                            +           ( v(k,j,i+2) - v(k,j,i-3) ) ) * adv_mom_5
@@ -2556,20 +2786,20 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit23 = REAL( IBITS(advc_flags_1(k,j-1,i),23,1), KIND = wp )
-             ibit22 = REAL( IBITS(advc_flags_1(k,j-1,i),22,1), KIND = wp )
-             ibit21 = REAL( IBITS(advc_flags_1(k,j-1,i),21,1), KIND = wp )
+             ibit14 = REAL( IBITS(advc_flags_m(k,j-1,i),14,1), KIND = wp )
+             ibit13 = REAL( IBITS(advc_flags_m(k,j-1,i),13,1), KIND = wp )
+             ibit12 = REAL( IBITS(advc_flags_m(k,j-1,i),12,1), KIND = wp )
 
              v_comp_l       = v(k,j,i) + v(k,j-1,i) - gv
              flux_s_v(k,tn) = v_comp_l * (                                    &
-                            ( 37.0_wp * ibit23 * adv_mom_5                    &
-                         +     7.0_wp * ibit22 * adv_mom_3                    &
-                         +              ibit21 * adv_mom_1                    &
+                            ( 37.0_wp * ibit14 * adv_mom_5                    &
+                         +     7.0_wp * ibit13 * adv_mom_3                    &
+                         +              ibit12 * adv_mom_1                    &
                             ) *                                               &
                                         ( v(k,j,i)   + v(k,j-1,i) )           &
-                     -      (  8.0_wp * ibit23 * adv_mom_5                    &
-                         +              ibit22 * adv_mom_3                    &
+                     -      (  8.0_wp * ibit14 * adv_mom_5                    &
+                         +              ibit13 * adv_mom_3                    &
                             ) *                                               &
                                         ( v(k,j+1,i) + v(k,j-2,i) )           &
-                     +      (           ibit23 * adv_mom_5                    &
+                     +      (           ibit14 * adv_mom_5                    &
                             ) *                                               &
                                         ( v(k,j+2,i) + v(k,j-3,i) )           &
@@ -2577,14 +2807,14 @@
 
              diss_s_v(k,tn) = - ABS( v_comp_l ) * (                           &
-                            ( 10.0_wp * ibit23 * adv_mom_5                    &
-                         +     3.0_wp * ibit22 * adv_mom_3                    &
-                         +              ibit21 * adv_mom_1                    &
+                            ( 10.0_wp * ibit14 * adv_mom_5                    &
+                         +     3.0_wp * ibit13 * adv_mom_3                    &
+                         +              ibit12 * adv_mom_1                    &
                             ) *                                               &
                                         ( v(k,j,i)   - v(k,j-1,i) )           &
-                     -      (  5.0_wp * ibit23 * adv_mom_5                    &
-                         +              ibit22 * adv_mom_3                    &
+                     -      (  5.0_wp * ibit14 * adv_mom_5                    &
+                         +              ibit13 * adv_mom_3                    &
                             ) *                                               &
                                         ( v(k,j+1,i) - v(k,j-2,i) )           &
-                     +      (           ibit23 * adv_mom_5                    &
+                     +      (           ibit14 * adv_mom_5                    &
                             ) *                                               &
                                         ( v(k,j+2,i) - v(k,j-3,i) )           &
@@ -2597,9 +2827,9 @@
              v_comp_l       = v(k,j,i) + v(k,j-1,i) - gv
              flux_s_v(k,tn) = v_comp_l * (                                    &
-                           37.0_wp * ( v(k,j,i) + v(k,j-1,i)   )              &
+                           37.0_wp * ( v(k,j,i)   + v(k,j-1,i)   )            &
                          -  8.0_wp * ( v(k,j+1,i) + v(k,j-2,i) )              &
                          +           ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
              diss_s_v(k,tn) = - ABS( v_comp_l ) * (                           &
-                           10.0_wp * ( v(k,j,i) - v(k,j-1,i)   )              &
+                           10.0_wp * ( v(k,j,i)   - v(k,j-1,i)   )            &
                          -  5.0_wp * ( v(k,j+1,i) - v(k,j-2,i) )              &
                          +           ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
@@ -2613,20 +2843,20 @@
        DO  k = nzb+1, nzb_max_l
 
-          ibit20 = REAL( IBITS(advc_flags_1(k,j,i),20,1), KIND = wp )
-          ibit19 = REAL( IBITS(advc_flags_1(k,j,i),19,1), KIND = wp )
-          ibit18 = REAL( IBITS(advc_flags_1(k,j,i),18,1), KIND = wp )
+          ibit11 = REAL( IBITS(advc_flags_m(k,j,i),11,1), KIND = wp )
+          ibit10 = REAL( IBITS(advc_flags_m(k,j,i),10,1), KIND = wp )
+          ibit9  = REAL( IBITS(advc_flags_m(k,j,i),9,1),  KIND = wp )
  
           u_comp(k) = u(k,j-1,i+1) + u(k,j,i+1) - gu
           flux_r(k) = u_comp(k) * (                                           &
-                     ( 37.0_wp * ibit20 * adv_mom_5                           &
-                  +     7.0_wp * ibit19 * adv_mom_3                           &
-                  +              ibit18 * adv_mom_1                           &
+                     ( 37.0_wp * ibit11 * adv_mom_5                           &
+                  +     7.0_wp * ibit10 * adv_mom_3                           &
+                  +              ibit9  * adv_mom_1                           &
                      ) *                                                      &
                                     ( v(k,j,i+1) + v(k,j,i)   )               &
-              -      (  8.0_wp * ibit20 * adv_mom_5                           &
-                  +              ibit19 * adv_mom_3                           &
+              -      (  8.0_wp * ibit11 * adv_mom_5                           &
+                  +              ibit10 * adv_mom_3                           &
                      ) *                                                      &
                                     ( v(k,j,i+2) + v(k,j,i-1) )               &
-              +      (           ibit20 * adv_mom_5                           &
+              +      (           ibit11 * adv_mom_5                           &
                      ) *                                                      &
                                     ( v(k,j,i+3) + v(k,j,i-2) )               &
@@ -2634,35 +2864,35 @@
 
           diss_r(k) = - ABS( u_comp(k) ) * (                                  &
-                     ( 10.0_wp * ibit20 * adv_mom_5                           &
-                  +     3.0_wp * ibit19 * adv_mom_3                           &
-                  +              ibit18 * adv_mom_1                           &
+                     ( 10.0_wp * ibit11 * adv_mom_5                           &
+                  +     3.0_wp * ibit10 * adv_mom_3                           &
+                  +              ibit9  * adv_mom_1                           &
                      ) *                                                      &
                                     ( v(k,j,i+1) - v(k,j,i)  )                &
-              -      (  5.0_wp * ibit20 * adv_mom_5                           &
-                  +              ibit19 * adv_mom_3                           &
+              -      (  5.0_wp * ibit11 * adv_mom_5                           &
+                  +              ibit10 * adv_mom_3                           &
                      ) *                                                      &
                                     ( v(k,j,i+2) - v(k,j,i-1) )               &
-              +      (           ibit20 * adv_mom_5                           &
+              +      (           ibit11 * adv_mom_5                           &
                      ) *                                                      &
                                     ( v(k,j,i+3) - v(k,j,i-2) )               &
                                            )
 
-          ibit23 = REAL( IBITS(advc_flags_1(k,j,i),23,1), KIND = wp )
-          ibit22 = REAL( IBITS(advc_flags_1(k,j,i),22,1), KIND = wp )
-          ibit21 = REAL( IBITS(advc_flags_1(k,j,i),21,1), KIND = wp )
+          ibit14 = REAL( IBITS(advc_flags_m(k,j,i),14,1), KIND = wp )
+          ibit13 = REAL( IBITS(advc_flags_m(k,j,i),13,1), KIND = wp )
+          ibit12 = REAL( IBITS(advc_flags_m(k,j,i),12,1), KIND = wp )
 
 
           v_comp(k) = v(k,j+1,i) + v(k,j,i)
           flux_n(k) = ( v_comp(k) - gv ) * (                                  &
-                     ( 37.0_wp * ibit23 * adv_mom_5                           &
-                  +     7.0_wp * ibit22 * adv_mom_3                           &
-                  +              ibit21 * adv_mom_1                           &
+                     ( 37.0_wp * ibit14 * adv_mom_5                           &
+                  +     7.0_wp * ibit13 * adv_mom_3                           &
+                  +              ibit12 * adv_mom_1                           &
                      ) *                                                      &
                                     ( v(k,j+1,i) + v(k,j,i)   )               &
-              -      (  8.0_wp * ibit23 * adv_mom_5                           &
-                  +              ibit22 * adv_mom_3                           &
+              -      (  8.0_wp * ibit14 * adv_mom_5                           &
+                  +              ibit13 * adv_mom_3                           &
                      ) *                                                      &
                                     ( v(k,j+2,i) + v(k,j-1,i) )               &
-              +      (           ibit23 * adv_mom_5                           &
+              +      (           ibit14 * adv_mom_5                           &
                      ) *                                                      &
                                     ( v(k,j+3,i) + v(k,j-2,i) )               &
@@ -2670,14 +2900,14 @@
 
           diss_n(k) = - ABS( v_comp(k) - gv ) * (                             &
-                     ( 10.0_wp * ibit23 * adv_mom_5                           &
-                  +     3.0_wp * ibit22 * adv_mom_3                           &
-                  +              ibit21 * adv_mom_1                           &
+                     ( 10.0_wp * ibit14 * adv_mom_5                           &
+                  +     3.0_wp * ibit13 * adv_mom_3                           &
+                  +              ibit12 * adv_mom_1                           &
                      ) *                                                      &
                                     ( v(k,j+1,i) - v(k,j,i)   )               &
-              -      (  5.0_wp * ibit23 * adv_mom_5                           &
-                  +              ibit22 * adv_mom_3                           &
+              -      (  5.0_wp * ibit14 * adv_mom_5                           &
+                  +              ibit13 * adv_mom_3                           &
                      ) *                                                      &
                                     ( v(k,j+2,i) - v(k,j-1,i) )               &
-              +      (           ibit23 * adv_mom_5                           &
+              +      (           ibit14 * adv_mom_5                           &
                      ) *                                                      &
                                     ( v(k,j+3,i) - v(k,j-2,i) )               &
@@ -2718,5 +2948,5 @@
 !--    calculated explicetely for the tendency at
 !--    the first w-level. For topography wall this is done implicitely by
-!--    advc_flags_1.
+!--    advc_flags_m.
        flux_t(nzb) = 0.0_wp
        diss_t(nzb) = 0.0_wp
@@ -2727,24 +2957,24 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit26 = REAL( IBITS(advc_flags_1(k,j,i),26,1), KIND = wp )
-          ibit25 = REAL( IBITS(advc_flags_1(k,j,i),25,1), KIND = wp )
-          ibit24 = REAL( IBITS(advc_flags_1(k,j,i),24,1), KIND = wp )
-
-          k_ppp = k + 3 * ibit26
-          k_pp  = k + 2 * ( 1 - ibit24  )
-          k_mm  = k - 2 * ibit26
+          ibit17 = REAL( IBITS(advc_flags_m(k,j,i),17,1), KIND = wp )
+          ibit16 = REAL( IBITS(advc_flags_m(k,j,i),16,1), KIND = wp )
+          ibit15 = REAL( IBITS(advc_flags_m(k,j,i),15,1), KIND = wp )
+
+          k_ppp = k + 3 * ibit17
+          k_pp  = k + 2 * ( 1 - ibit15  )
+          k_mm  = k - 2 * ibit17
 
           w_comp(k) = w(k,j-1,i) + w(k,j,i)
           flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
-                     ( 37.0_wp * ibit26 * adv_mom_5                           &
-                  +     7.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
+                     ( 37.0_wp * ibit17 * adv_mom_5                           &
+                  +     7.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
                      ) *                                                      &
                                 ( v(k+1,j,i)   + v(k,j,i)    )                &
-              -      (  8.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
+              -      (  8.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
                      ) *                                                      &
                                 ( v(k_pp,j,i)  + v(k-1,j,i)  )                &
-              +      (           ibit26 * adv_mom_5                           &
+              +      (           ibit17 * adv_mom_5                           &
                      ) *                                                      &
                                 ( v(k_ppp,j,i) + v(k_mm,j,i) )                &
@@ -2752,14 +2982,14 @@
 
           diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
-                     ( 10.0_wp * ibit26 * adv_mom_5                           &
-                  +     3.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
+                     ( 10.0_wp * ibit17 * adv_mom_5                           &
+                  +     3.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
                      ) *                                                      &
                                 ( v(k+1,j,i)   - v(k,j,i)    )                &
-              -      (  5.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
+              -      (  5.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
                      ) *                                                      &
                                 ( v(k_pp,j,i)  - v(k-1,j,i)  )                &
-              +      (           ibit26 * adv_mom_5                           &
+              +      (           ibit17 * adv_mom_5                           &
                      ) *                                                      &
                                 ( v(k_ppp,j,i) - v(k_mm,j,i) )                &
